import urllib
import io
from io import BytesIO
import requests,re,arrow, ftplib
from datetime import datetime
from os.path import join
from pathlib import Path
import sys,os
from unidecode import unidecode
import operator
from datetime import timedelta
import pytz
import json
# import mlb_token

scraper_name = Path(__file__).stem.split('_',1)[-1]

myPath = sys.path[0]
dataPath = join(myPath,'Data', scraper_name) 
# dataPath = join(f"/MLB/")        
dataTemp = join(dataPath, 'temp' )         
xmlPath = join(dataPath, 'xml' )         
tokenPath = join(myPath,'Data','Tokens')         

if not os.path.exists(dataPath) : os.makedirs(dataPath)
if not os.path.exists(dataTemp) : os.makedirs(dataTemp) 
if not os.path.exists(xmlPath) : os.mkdir(xmlPath)

# tidy_me([dataPath, xmlPath, dataTemp] )
# f = open (join(dataPath, 'mlb.xml') , 'w').close()

usa_zone = pytz.timezone('US/Eastern') 
uk_zone = pytz.timezone('Europe/London') 

####
def tidy_me(path_list) :
    ## Remove files from path list folders      
    if not path_list : return  
    for temp_path in path_list :
        allTEMP = [f for f in os.listdir(temp_path) if os.path.isfile(join(temp_path, f))]                   
        delFiles = []     
        for d in allTEMP :
            delFiles.append(d)       
            # if d.endswith('.xml') or d.endswith('.m3u') or d.endswith('.m3u8') or d.endswith('.json'): delFiles.append(d)       
        for f in delFiles :
            # print (f)
            # os.remove(join(temp_path, f))
            if not 'safe' in f : os.remove(join(temp_path, f))
          
    return 

def print_me(ps1, ps2=None, col1='cyan' , col2 = 'yellow', print_type='std' ) :
    if print_type == 'colour' :                                
        if ps1 : print (colored(ps1 , col1))                          
        if ps2 : print (colored(ps2 , col2))                          
    else :                            
        if ps1 : print (ps1)                   
        if ps2 : print (ps2)     
    return

def writeJS(wData, wFile) :
    f3 = open(wFile,'w')
    json.dump(wData,f3,indent=4,sort_keys=False)
    # json.dump(wData,f3,indent=4)
    f3.close()    
      
######
tidy_me([dataPath, xmlPath, dataTemp] )

pString1 = ('\n' + f'<---- {scraper_name} Scraper ---->') 
pString2 =  ( 'Getting data from site .... ')
print_me(pString1, pString2, 'green', 'green' )

start = 'http://mlb.mlb.com/mlb/images/devices/ballpark/1920x1080/color/'
usa_date = datetime.now(usa_zone)
start_date = usa_date.strftime ('%Y-%m-%d')
event_date = usa_date.strftime ('%d-%m-%Y')

User_Agent = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36'
headers = {'User_Agent': User_Agent}
user = '|User-Agent=At Bat/26884 CFNetwork/894 Darwin/17.4.0&Authorization='
cookie = '&Cookie=ipid=43548555;'

# with open(join(tokenPath, 'mlb_token.xml')) as file:
#     contents = file.read()
# contents = requests.get("https://magnetic1.ratpack.appboxes.co/jet/mlb.txt").text
contents = requests.get("https://magnetic.website/jet/mlb.txt").text

jsdata = {'items' : []} 
jsinfo = []

############ 
# For YouTube Game of Week
# Activates on Wednesday only
yt_game_name = 'MLB YouTube Game of The Week ' 
yt_game_title = "[COLOR skyblue]MLB Game of The Week[COLOR white][I] (YouTube)[/I][/COLOR]"
yt_game_link = "https://www.youtube.com/playlist_list=PLL-lmlkrmJanAeIIfwSpaB-HpDYmW6-rF"
yt_game_sort = 1000000000.0
yt_fan = "https://www.thesportsdb.com/images/media/league/fanart/xyvvtv1423694425.jpg" 
yt_thumb = "https://www.thesportsdb.com/images/media/league/trophy/55ggh41617528995.png" 

if usa_date.strftime('%a').lower() == 'wed' :
    print ('YouTube Game of the Week added') 
    jsinfo.append({"link" : yt_game_link, "type" : 'dir' , "title2" : yt_game_name, "title" : yt_game_title, "id" : "empty", "thumbnail" : "https://i.imgur.com/zJ4OcDf.png", "fanart" : yt_fan, "game_time" : yt_game_sort})
############
# espn_link = "plugin://plugin.video.madtitansports/search_json/https://magnetic1.ratpack.appboxes.co/jet/newchannels.json?query=espn&dialog=true"



f = open (join(xmlPath, 'mlb.xml') , 'w').close()

refresh = contents
url = "https://us.edge.bamgrid.com/token"
payload = "grant_type=refresh_token&latitude=0&longitude=0&platform=browser&refresh_token="+refresh
headers = {
    'x-bamsdk-platform': "macintosh",
    'Origin': "https://www.mlb.com",
    'authorization': "Bearer bWxidHYmYnJvd3NlciYxLjAuMA.VfmGMGituFykTR89LFD-Gr5G-lwJ9QbHfXXNBMkuM9M",
    'content-type': "application/x-www-form-urlencoded",
    'x-bamsdk-version': "3.4",
    'accept': "application/json",
    'Referer': "https://www.mlb.com/tv/g565803/ve5fc3822-265a-424b-b415-ae98e878eabb",
    'User-Agent': "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36",
    'cache-control': "no-cache",
    }
response = requests.request("POST", url, data=payload, headers=headers)

match = re.compile('"access_token":"(.+?)".+?refresh_token":"(.+?)"',re.DOTALL).findall(response.text)
for access_token,refresh_token in match:
    main_api = 'http://statsapi.mlb.com/api/v1/schedule?sportId=1&startDate=' + start_date + '&endDate=' + start_date + '&hydrate=team,linescore,flags,liveLookin,person,stat,probablePitcher,game(content(summary,media(epg)),tickets)&language=en'
    json_data = requests.get(main_api).json()
    date = json_data ['dates'][0]['date']
    print_me(date)
    total = json_data ['totalGames']
    pString1= ('Total Games Played Today: ' + str(total) )
    print_me(pString1)
    in_progress = json_data ['totalGamesInProgress']
    pString1 = ('Total Games in Progress: ' + str(in_progress) )
    pString2 = ('---------------------------------') 
    print_me(pString1, pString2, 'cyan', 'cyan' )
    
    team = json_data ['dates'][0]['games']
    for t in team:            
        link_list = []   
        sub_list = []   
        progress = t['status']['detailedState']
        gameDate = t['gameDate']
        game_date = arrow.get(gameDate)
        game_date = game_date.format('MM-DD')
        game_time = arrow.get(gameDate)
        game_time = game_time.to('US/Eastern').format('h:mm A')
        game_sort = arrow.get(gameDate).timestamp()
        
        away = t['teams']['away']['team']['name']
        home = t['teams']['home']['team']['name']
        fan = t['teams']['home']['team']['venue']['id']
        name = (away+' @ '+ home+' ' + game_time+' '+ progress)
        name3 = ('[B]'+away+' @ '+ home+'[/B] ' + game_time+' '+ '[B][COLORlightblue]National TV[/B][/COLOR]') 
        image = (start+str(fan)+".jpg") 
        print ('\n' + away+' @ '+ home+' ' + game_time+' '+ progress) 
 
        main_date = arrow.get(gameDate)
        usa_date = main_date.to('US/Eastern')
        uk_date = usa_date.to('Europe/London')
        
        name2 = ('[B][COLORlightblue]' + uk_date.format('h:mmA ') + '[COLOR khaki]' + usa_date.format('(h:mmA ZZZ) ')+ '[COLORwhite]' + away+' @ '+ home+' '+ progress + '[/B][/COLOR]').replace('AM', 'am') .replace('PM', 'pm') 
        
        
        # if usa_date.strftime('%a').lower() == 'sun' :
        #             print ('ESPN game added') 
        #             jsinfo.append({"link" : espn_link, "type" : 'item' , "title2" : name, "title" : name3 , "id" : "empty", "thumbnail" : "https://i.imgur.com/zJ4OcDf.png", "fanart" : image, "game_time" : game_sort})           
        try:
            content = t['content']['media']['epg'][0]['items']
            for c in content:
                media = c['id']
                contentId = c['contentId']
                feed = c['mediaFeedType']
                media_id = c['mediaId']
                url = "https://playback.svcs.mlb.com/events/"+contentId+"/media/"+media_id+"/scenarios/browser-dfp~ssai"
                headers = {
                    'x-bamsdk-version': "3.4",
                    'accept': "application/vnd.media-service+json; version=2",
                    'x-bamsdk-platform': "macintosh",
                    'Origin': "https://www.mlb.com",
                    'Referer': "https://www.mlb.com/tv/",
                    'User-Agent': "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36",
                    'authorization': '"'+access_token+'"',
                    'cache-control': "no-cache",
                    }

                response = requests.request("GET", url, headers=headers)
                # match = re.compile('"slide":"(.+?)"',re.DOTALL).findall(response.text)
                match = re.compile('"complete":"(.+?)"',re.DOTALL).findall(response.text)
                                    
                for mylink in match: 
                    link_temp = mylink+user+access_token+cookie
                    link = unidecode (link_temp) 
                    # link1 = link.replace('master_desktop_slide_gdfp.m3u8','5600K/5600_complete.m3u8') +' ('+feed+' '+ '5600)'
                    # link2 = link.replace('master_desktop_slide_gdfp.m3u8','3500K/3500_complete.m3u8') +' ('+feed+' '+ '3500)'
                    # link3 = link.replace('master_desktop_slide_gdfp.m3u8','1800K/1800_complete.m3u8') +' ('+feed+' '+ '1800)'
                    # link4 = link.replace('master_desktop_slide_gdfp.m3u8','1200K/1200_complete.m3u8') +' ('+feed+' '+ '1200)'
                    link1 = link.replace('master_desktop_complete_gdfp.m3u8','5600K/5600_complete.m3u8') +' ('+feed+' '+ '5600)'
                    link2 = link.replace('master_desktop_complete_gdfp.m3u8','3500K/3500_complete.m3u8') +' ('+feed+' '+ '3500)'
                    link3 = link.replace('master_desktop_complete_gdfp.m3u8','1800K/1800_complete.m3u8') +' ('+feed+' '+ '1800)'
                    link4 = link.replace('master_desktop_complete_gdfp.m3u8','1200K/1200_complete.m3u8') +' ('+feed+' '+ '1200)'
                            
                    link_list.append( link1)
                    link_list.append( link2)
                    link_list.append( link3)
                    link_list.append( link4)
                    
                    sub_list.append( link1)
                    sub_list.append( link2)
                    sub_list.append( link3)
                    sub_list.append( link4)
        except:
            pass
            
        if not progress.lower() ==  'finished' :     
                    jsinfo.append({"link" : link_list, "type" : 'item' , "title2" : name, "title" : name2, "id" : "empty", "thumbnail" : "https://i.imgur.com/zJ4OcDf.png", "fanart" : image, "game_time" : game_sort})
        
                    
                    f = open (join(xmlPath, 'mlb.xml') , 'a')
                    f.write('\n' + '<item>' + '\n')
                    f.write('\t' + '<title>' + name2+ '</title>' + '\n')
                    f.write('\t' + '<link>' + '\n')
                    for x in sub_list :
                        f.write('\t' + '\t' + '<sublink>' + x + '</sublink>'+ '\n')
                    f.write('\t' + '</link>' + '\n')
                    f.write('\t' + '<thumbnail>'+'</thumbnail>'+ '\n')
                    f.write('\t' + '<fanart>'+ image +'</fanart>' + '\n')
                    f.write('</item>' + '\n')
                    f.close()
if jsinfo : 
    jsinfo.sort(key = operator.itemgetter('game_time', 'title') , reverse = False)     
    for i in jsinfo :
        jsdata['items'].append(i)
        
    writeJS(jsdata, join(dataPath, 'mlb.json'))  
else : ('No jsdata')                                                                    

json_filename = join(dataPath, 'mlb.json')
filename = json_filename.split("/")[-1]

# Open the JSON file and create a file-like object
with open(json_filename, "rb") as f:
    data = io.BytesIO(f.read())

ftp = ftplib.FTP()
ftp.connect("magnetic.website", port=10021)
ftp.login("jet", "jetjet71!")
ftp.cwd("/srv/http/jet/")
ftp.storbinary("STOR " + filename, data)  # Provide the file-like object as the second argument
ftp.close()

print("Done.")



